



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[原创] PHP 使用Redis实现锁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[原创] PHP 使用Redis实现锁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 00:14:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><div>
<div>目录</div>
<ul><li><a href="#锁实现的注意点" rel="external nofollow noreferrer">锁实现的注意点</a></li>
<li><a href="#加锁" rel="external nofollow noreferrer">加锁</a>
<ul><li><a href="#connect-与-pconnect" rel="external nofollow noreferrer">connect 与 pconnect</a></li></ul></li>
<li><a href="#解锁" rel="external nofollow noreferrer">解锁</a></li>
<li><a href="#redis-中使用-lua-脚本的注意点" rel="external nofollow noreferrer">Redis 中使用 Lua 脚本的注意点</a></li>
<li><a href="#redis集群分布式锁" rel="external nofollow noreferrer">Redis集群分布式锁</a>
<ul><li><a href="#redlock-算法" rel="external nofollow noreferrer">RedLock 算法</a></li></ul></li></ul>
</div>
<h1>锁实现的注意点</h1>
<ol><li>互斥: 任意时刻, 只能有一个客户端获得锁</li>
<li>不会死锁: 客户端持有锁期间崩溃, 没有主动解除锁, 能保证后续的其他客户端获得锁</li>
<li>锁归属标识: 加锁和解锁的必须是同一个客户端, 客户端不能解掉非自己持有的锁(锁应具备标识)</li></ol>
<p>如果是Redis集群, 还得考虑具有<strong>容错性:</strong> 只要大部分Redis节点正常运行, 客户端就可以加锁和解锁.</p>
<p>以下只考虑 Redis单机部署的 场景.</p>
<p>如果是Redis集群部署, 可以使用</p>
<h1>加锁</h1>
<p>php 加锁示例</p>
<pre class="prettyprint linenums"><code>$redis = new Redis();<br />
$redis-&gt;pconnect(&quot;127.0.0.1&quot;, 6379);<br />
$redis-&gt;auth(&quot;password&quot;);	// 密码验证<br />
$redis-&gt;select(1);	// 选择所使用的数据库, 默认有16个

$key = &quot;...&quot;;<br />
$value = &quot;...&quot;;<br />
$expire = 3;

// 参数解释 ↓<br />
// $value 加锁的客户端请求标识, 必须保证在所有获取锁清秋的客户端里保持唯一, 满足上面的第3个条件: 加锁/解锁的是同一客户端<br />
// &quot;NX&quot; 仅在key不存在时加锁, 满足条件1: 互斥型<br />
// &quot;EX&quot; 设置锁过期时间, 满足条件2: 避免死锁<br />
$redis-&gt;set($key, $value, [&quot;NX&quot;, &quot;EX&quot; =&gt; $expire])<br />
</code></pre>
<p>执行上面代码结果:</p>
<ol><li>$key 对应的锁不存在, 进行加锁操作</li>
<li>$key 对应的锁已存在, 什么也不做</li></ol>
<p>加锁容易错误的点:</p>
<ul><li><p>使用 <code>setnx</code> 和 <code>expire</code> 的组合</p>
<p>原因: 若在 <code>setnx</code> 后脚本崩溃会导致死锁</p></li></ul>
<p><code>$value</code> 客户端标识的:</p>
<ul><li>简单点就用 毫秒级unix时间戳 + 客户端标识(大部分情况下够用了)</li>
<li>使用其他算法确保生成唯一随机值</li></ul>
<h2>connect 与 pconnect</h2>
<p>在php中, 若使用 <code>pconnect</code> 连接redis, 则在当前脚本声明周期结束后, 与redis建立的连接仍会保留, 直到对应fpm进程的生命周期结束, 同时在下一次请求时, fpm会重用该连接.</p>
<p>即该连接的生命周期是 fpm 进程的生命周期, 而非一次php脚本的执行.</p>
<p>若代码使用 <code>pconnect</code>, <code>close</code> 的作用仅是使当前php脚本不能再进行redis请求, 并没有真正关闭与redis的连接, 连接在后续请求中仍然会被重用.</p>
<blockquote><p>pconnect函数在线程版本中不能被使用<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/387576/201902/387576-20190226152636997-1403376612.png"></p></blockquote>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/387576/201902/387576-20190226152644897-928669624.png"></p>
<h1>解锁</h1>
<p>php解锁示例: 使用lua脚本</p>
<pre class="prettyprint linenums"><code>$key = &quot;...&quot;;<br />
$identification = &quot;...&quot;;<br />
// KEYS 和 ARGV 是lua脚本中的全局变量<br />
$script = &lt;&lt;&lt; EOF<br />
if redis.call(&quot;get&quot;, KEYS[1]) == ARGV[1] then<br />
	return redis.call(&quot;del&quot;, KEYS[1])<br />
then<br />
	return 0<br />
end<br />
EOF;<br />
# $result = $redis-&gt;eval($script, [$key, $identification], 1);<br />
// 返回结果 &gt;0 表示解锁成功<br />
// php中参数的传递顺序与标准不一样, 注意区分<br />
// 第2个参数表示传入的 KEYS 和 ARGV, 通过第3个参数来区分, KEYS 在前, ARGV 在后<br />
// 第3个参数表示传入的 KEYS 的个数<br />
$result = $redis-&gt;evaluate($script, [$key, $identification], 1);<br />
</code></pre>
<p>使用Lua脚本的原因:</p>
<ul><li><p>避免误删其他客户端加的锁</p>
<blockquote><p>eg. 某个客户端获取锁后做其他操作过久导致锁被自动释放, 这时候要避免这个客户端删除已经被其他客户端获取的锁, 这就用到了锁的标识.</p></blockquote></li>
<li><p>lua 脚本中执行 <code>get</code> 和 <code>del</code> 是原子性的, 整个lua脚本会被当做一条命令来执行</p></li>
<li><p>即使 <code>get</code> 后锁刚好过期, 此时也不会被其他客户端加锁</p></li></ul>
<blockquote><p>eval命令执行Lua代码的时候，Lua代码将被当成一个命令去执行，并且直到eval命令执行完成，Redis才会执行其他命令。</p>
<p>由于 script 执行的原子性, 所以不要在script中执行过长开销的程序，否则会验证影响其它请求的执行。</p></blockquote>
<p>解锁容易错误的点:</p>
<ul><li><p>直接 <code>del</code> 删除键</p>
<p>原因: 可能移除掉其他客户端加的锁(在自己的锁已过期情况下)</p></li>
<li><p><code>get</code>判断锁归属, 若符合再 <code>del</code></p>
<p>原因: 非原子性操作, 若在 <code>get</code> 后锁过期了, 此时别的客户端进行加锁操作, 这里的 <code>del</code> 就会错误的将其他客户端加的锁解开.</p></li></ul>
<h1>Redis 中使用 Lua 脚本的注意点</h1>
<p>↓ 这一段内容转载自 <a href="https://blog.csdn.net/zhouzme/article/details/53046606" rel="external nofollow noreferrer">https://blog.csdn.net/zhouzme/article/details/53046606</a></p>
<p><strong>注意点:</strong></p>
<ol><li><p>Redis 会把<strong>所有执行过的脚本都缓存在内存中</strong></p></li>
<li><p>Redis 在<strong>重启</strong>的时候会<strong>释放掉</strong>之前保存的脚本</p></li>
<li><p>Lua 脚本中所需要用到的键名以及参数一定要使用 KEYS 和 ARGV 来替换，千万不要写死在代码中，除非你百分百确定每次请求时他们是固定不变的值，特别是涉及到 时间，随机数的，一定要用参数代入，因为 <strong>Redis 每次使用 script 都会校验脚本缓存中是否已存在相同脚本，否则就会存储到缓存中</strong>，如果你的脚本很长，且每次请求存在不同的变量值，则会生成无数多个脚本缓存，你将会发现Redis占用的内存会唰唰唰的往上涨，我一开始因为key 和 参数太多，分开写太麻烦了，就图省事方便，直接把变量拼接到脚本里面，结果发现内存不停的涨，很是抓狂，找了好久才发现是这么个原因。<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/387576/201902/387576-20190226152736830-1821638455.png"></p></li>
<li><p>Lua 中脚本定义变量一定要<strong>使用局部变量</strong>, 即 <code>local var = 1</code>, 局部变量只在所定义的块(指控制结构, 函数或chunk等)内有效, 使用局部变量可以避免命名冲突 并且访问更快(lua中局部变量和全局变量存储方式是不一样的)</p></li>
<li><p>如果Lua脚本写的比较长，非本地或局域网的情况下，建议使用 <strong>SHA 签名</strong>的方法来调用，这样节省带宽，但对性能似乎没什么直接的提升。这里对小白普及下我理解的原理就是 Redis 会把每个脚本都生成唯一签名，把脚本作为函数体，并使用该签名作为脚本的函数名放到缓存中，所以后面调用就只需要传一个 SHA 签名就可以调用该函数了，精简很多了。同一个脚本生成的签名都是相同的，所以SHA签名可以先在本地生成，然后在服务器上 script load 一次脚本，程序中只需保存和使用该签名即可。另外需要注意的是，脚本如果被改动哪怕一个换行或一个空格（这些容易被忽略或误操作）都必须重新 load 来获取新的 SHA</p>
<blockquote><p>注意：获取 SHA 签名是单独的功能，不要放在你的正常流程中，当本地开发时就可以生成SHA，把字符串写死在流程中。同样的脚本，Reids是始终生成相同的签名的。<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/387576/201902/387576-20190226152745538-1962489855.png"></p></blockquote></li>
<li><p>通过 eval 带入的 <strong>ARGV 参数如果原来是数字的，会被转换为字符串</strong>，如果你的逻辑中需要判断该变量 &gt; 0 或 &lt; 0 之类的数字判断则必须进行字符串到数字的转换，使用 <code>tonumber()</code> 方法<code> if (tonumber(ARGV[1]) &gt; 0) then return 1; end;</code></p></li>
<li><p>我测试了几个 lua script 与 PIPELINE 处理对比，发现 script 的效率一般比 PIPELINE 高 30% ~ 40% 左右<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/387576/201902/387576-20190226152755982-484713166.png"></p></li></ol>
<h1>Redis集群分布式锁</h1>
<p>Redis 集群相对单机来说, 需要考虑一个 <strong>容错性</strong>, 设计上更为复杂</p>
<p>由于这个我也从未实践过, 先贴一个官方的教程贴压压惊</p>
<p><a href="https://github.com/antirez/redis-doc/blob/master/topics/distlock.md" rel="external nofollow noreferrer">https://github.com/antirez/redis-doc/blob/master/topics/distlock.md</a></p>
<p>对应的翻译: <a href="http://ifeve.com/redis-lock/" rel="external nofollow noreferrer">http://ifeve.com/redis-lock/</a></p>
<h2>RedLock 算法</h2>
<p>官方给出了一个 RedLock 算法</p>
<p>情景: 当前有N个完全独立的Redis master节点, 分别部署在不同的主机上</p>
<p>客户端获取锁的操作:</p>
<ol><li>使用相同key和唯一值(作为value)同时向这N个redis节点请求锁, 锁的超时时间应该 &gt;&gt; 超时时间(考虑到请求耗时), 若某个节点阻塞了了应尽快跳过</li>
<li>计算步骤1消耗的时间, 若总消耗时间超过超时时间, 则认为锁失败. 客户端需在大多数(超过一半)的节点上成功获取锁, 才认为是锁成功.</li>
<li>如果锁成功了, 则该锁有效时间就是  锁原始有效时间 - 步骤1消耗的时间</li>
<li>如果锁失败了(超时或无法获取超过一半 N/2 + 1 实例的锁), 客户端会到每个节点释放锁(是每个, 即使之前认为加锁失败的节点)</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxx3r0q.html">设计模式-观察者模式&lpar;List列表维护观察者&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8znov18.html">响应式 css</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6mx58.html">dojo对数组的处理函数，dojo&period;forEach、dojo&period;every、 dojo&period;some、 dojo&period;map等</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q24xxl8.html">CSS3参考手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4e1le9.html">spring MVC的困惑--url-pattern的&sol;和&sol;&ast;有区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mx7y1q.html">夺命雷公狗---node&period;js---8url模块和util模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdkloq.html">JavaScript基于对象编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdm1x8.html">Linux系统目录（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdx7k9.html">SOD开源框架MSF（消息服务框架）介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pde6x49.html">&amp;lt&semi;&amp;lt&semi;Senium2自动化测试&amp;gt&semi;&amp;gt&semi;读书笔记一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ojmyq.html">项目总结2&mdash;&mdash;mybatis配置的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m3le38.html">git冲突时解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0www8.html">lArea&period;js 城市选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpped8.html">Linux&amp;&num;160&semi;Linux下最大文件描述符设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjj2mq.html">《Oracle DBA工作笔记：运维、数据迁移与性能调优》 PDF  下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy7d5d9.html">Py中re&period;sub学习【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvel12y9.html">Uncaught TypeError&colon; &lowbar;react2&period;default&period;createContext is not a function</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v3xz6q.html">angularjs ng-if ng-show ng-hide区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvke1mq.html">PHP的strtotime&lpar;&rpar;函数2038年bug问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pzmv0q.html">洛谷P2287 &lbrack;HNOI2004&rsqb;最佳包裹（三维凸包）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyvjjmmq.html">golang之切片</a>
			</li>
						<li><a href="https://www.batexi.com/a/902xgp4q.html">Please ensure that adb is correctly located at 。。。。。。。。。。。。</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pvlz5q.html">java如何集成支付宝移动快捷支付功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppo0n79.html">UVa 1616 Caravan Robbers （二分&plus;贪心）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zknm4v8.html">Appium之uiautomator定位元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnz36jq.html">团体程序设计天梯赛L2-001 紧急救援                                                                                            2017-03-22 17&colon;25             93人阅读              评论&lpar;0&rpar;              收藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v7zz5q.html">python中GUI使用小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx23n108.html">Linux tomcat 添加开机启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn25y4q.html">WPF TriggerAction弹出子窗体 TargetedTrigger、TargetedTriggerAction用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e5o2e9.html">MVC中用jQuery加BootStrap实现动态增加删除文本输入框！</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
